Index: lemon/max_matching.h
===================================================================
--- lemon/max_matching.h	(revision 573)
+++ lemon/max_matching.h	(revision 550)
@@ -283,5 +283,5 @@
 
         while (base != nca) {
-          (*_ear)[node] = arc;
+          _ear->set(node, arc);
 
           Node n = node;
@@ -290,5 +290,5 @@
             Arc a = (*_ear)[n];
             n = _graph.target(a);
-            (*_ear)[n] = _graph.oppositeArc(a);
+            _ear->set(n, _graph.oppositeArc(a));
           }
           node = _graph.target((*_matching)[base]);
@@ -296,5 +296,5 @@
           _tree_set->erase(node);
           _blossom_set->insert(node, _blossom_set->find(base));
-          (*_status)[node] = EVEN;
+          _status->set(node, EVEN);
           _node_queue[_last++] = node;
           arc = _graph.oppositeArc((*_ear)[node]);
@@ -305,5 +305,5 @@
       }
 
-      (*_blossom_rep)[_blossom_set->find(nca)] = nca;
+      _blossom_rep->set(_blossom_set->find(nca), nca);
 
       {
@@ -314,5 +314,5 @@
 
         while (base != nca) {
-          (*_ear)[node] = arc;
+          _ear->set(node, arc);
 
           Node n = node;
@@ -321,5 +321,5 @@
             Arc a = (*_ear)[n];
             n = _graph.target(a);
-            (*_ear)[n] = _graph.oppositeArc(a);
+            _ear->set(n, _graph.oppositeArc(a));
           }
           node = _graph.target((*_matching)[base]);
@@ -327,5 +327,5 @@
           _tree_set->erase(node);
           _blossom_set->insert(node, _blossom_set->find(base));
-          (*_status)[node] = EVEN;
+          _status->set(node, EVEN);
           _node_queue[_last++] = node;
           arc = _graph.oppositeArc((*_ear)[node]);
@@ -336,5 +336,5 @@
       }
 
-      (*_blossom_rep)[_blossom_set->find(nca)] = nca;
+      _blossom_rep->set(_blossom_set->find(nca), nca);
     }
 
@@ -345,9 +345,9 @@
       Node odd = _graph.target(a);
 
-      (*_ear)[odd] = _graph.oppositeArc(a);
+      _ear->set(odd, _graph.oppositeArc(a));
       Node even = _graph.target((*_matching)[odd]);
-      (*_blossom_rep)[_blossom_set->insert(even)] = even;
-      (*_status)[odd] = ODD;
-      (*_status)[even] = EVEN;
+      _blossom_rep->set(_blossom_set->insert(even), even);
+      _status->set(odd, ODD);
+      _status->set(even, EVEN);
       int tree = _tree_set->find((*_blossom_rep)[_blossom_set->find(base)]);
       _tree_set->insert(odd, tree);
@@ -363,9 +363,9 @@
       int tree = _tree_set->find((*_blossom_rep)[_blossom_set->find(even)]);
 
-      (*_matching)[odd] = _graph.oppositeArc(a);
-      (*_status)[odd] = MATCHED;
+      _matching->set(odd, _graph.oppositeArc(a));
+      _status->set(odd, MATCHED);
 
       Arc arc = (*_matching)[even];
-      (*_matching)[even] = a;
+      _matching->set(even, a);
 
       while (arc != INVALID) {
@@ -373,7 +373,7 @@
         arc = (*_ear)[odd];
         even = _graph.target(arc);
-        (*_matching)[odd] = arc;
+        _matching->set(odd, arc);
         arc = (*_matching)[even];
-        (*_matching)[even] = _graph.oppositeArc((*_matching)[odd]);
+        _matching->set(even, _graph.oppositeArc((*_matching)[odd]));
       }
 
@@ -381,10 +381,10 @@
            it != INVALID; ++it) {
         if ((*_status)[it] == ODD) {
-          (*_status)[it] = MATCHED;
+          _status->set(it, MATCHED);
         } else {
           int blossom = _blossom_set->find(it);
           for (typename BlossomSet::ItemIt jt(*_blossom_set, blossom);
                jt != INVALID; ++jt) {
-            (*_status)[jt] = MATCHED;
+            _status->set(jt, MATCHED);
           }
           _blossom_set->eraseClass(blossom);
@@ -428,6 +428,6 @@
       createStructures();
       for(NodeIt n(_graph); n != INVALID; ++n) {
-        (*_matching)[n] = INVALID;
-        (*_status)[n] = UNMATCHED;
+        _matching->set(n, INVALID);
+        _status->set(n, UNMATCHED);
       }
     }
@@ -439,6 +439,6 @@
       createStructures();
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_matching)[n] = INVALID;
-        (*_status)[n] = UNMATCHED;
+        _matching->set(n, INVALID);
+        _status->set(n, UNMATCHED);
       }
       for (NodeIt n(_graph); n != INVALID; ++n) {
@@ -447,8 +447,8 @@
             Node v = _graph.target(a);
             if ((*_matching)[v] == INVALID && v != n) {
-              (*_matching)[n] = a;
-              (*_status)[n] = MATCHED;
-              (*_matching)[v] = _graph.oppositeArc(a);
-              (*_status)[v] = MATCHED;
+              _matching->set(n, a);
+              _status->set(n, MATCHED);
+              _matching->set(v, _graph.oppositeArc(a));
+              _status->set(v, MATCHED);
               break;
             }
@@ -470,6 +470,6 @@
 
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_matching)[n] = INVALID;
-        (*_status)[n] = UNMATCHED;
+        _matching->set(n, INVALID);
+        _status->set(n, UNMATCHED);
       }
       for(EdgeIt e(_graph); e!=INVALID; ++e) {
@@ -478,11 +478,11 @@
           Node u = _graph.u(e);
           if ((*_matching)[u] != INVALID) return false;
-          (*_matching)[u] = _graph.direct(e, true);
-          (*_status)[u] = MATCHED;
+          _matching->set(u, _graph.direct(e, true));
+          _status->set(u, MATCHED);
 
           Node v = _graph.v(e);
           if ((*_matching)[v] != INVALID) return false;
-          (*_matching)[v] = _graph.direct(e, false);
-          (*_status)[v] = MATCHED;
+          _matching->set(v, _graph.direct(e, false));
+          _status->set(v, MATCHED);
         }
       }
@@ -498,5 +498,5 @@
           (*_blossom_rep)[_blossom_set->insert(n)] = n;
           _tree_set->insert(n);
-          (*_status)[n] = EVEN;
+          _status->set(n, EVEN);
           processSparse(n);
         }
@@ -513,5 +513,5 @@
           (*_blossom_rep)[_blossom_set->insert(n)] = n;
           _tree_set->insert(n);
-          (*_status)[n] = EVEN;
+          _status->set(n, EVEN);
           processDense(n);
         }
@@ -1549,7 +1549,7 @@
         Value pot = (*_node_data)[bi].pot;
 
-        (*_matching)[base] = matching;
+        _matching->set(base, matching);
         _blossom_node_list.push_back(base);
-        (*_node_potential)[base] = pot;
+        _node_potential->set(base, pot);
       } else {
 
@@ -1645,15 +1645,15 @@
 
       for (ArcIt e(_graph); e != INVALID; ++e) {
-        (*_node_heap_index)[e] = BinHeap<Value, IntArcMap>::PRE_HEAP;
+        _node_heap_index->set(e, BinHeap<Value, IntArcMap>::PRE_HEAP);
       }
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_delta1_index)[n] = _delta1->PRE_HEAP;
+        _delta1_index->set(n, _delta1->PRE_HEAP);
       }
       for (EdgeIt e(_graph); e != INVALID; ++e) {
-        (*_delta3_index)[e] = _delta3->PRE_HEAP;
+        _delta3_index->set(e, _delta3->PRE_HEAP);
       }
       for (int i = 0; i < _blossom_num; ++i) {
-        (*_delta2_index)[i] = _delta2->PRE_HEAP;
-        (*_delta4_index)[i] = _delta4->PRE_HEAP;
+        _delta2_index->set(i, _delta2->PRE_HEAP);
+        _delta4_index->set(i, _delta4->PRE_HEAP);
       }
 
@@ -1667,5 +1667,5 @@
           }
         }
-        (*_node_index)[n] = index;
+        _node_index->set(n, index);
         (*_node_data)[index].pot = max;
         _delta1->push(n, max);
@@ -2742,7 +2742,7 @@
         Value pot = (*_node_data)[bi].pot;
 
-        (*_matching)[base] = matching;
+        _matching->set(base, matching);
         _blossom_node_list.push_back(base);
-        (*_node_potential)[base] = pot;
+        _node_potential->set(base, pot);
       } else {
 
@@ -2832,12 +2832,12 @@
 
       for (ArcIt e(_graph); e != INVALID; ++e) {
-        (*_node_heap_index)[e] = BinHeap<Value, IntArcMap>::PRE_HEAP;
+        _node_heap_index->set(e, BinHeap<Value, IntArcMap>::PRE_HEAP);
       }
       for (EdgeIt e(_graph); e != INVALID; ++e) {
-        (*_delta3_index)[e] = _delta3->PRE_HEAP;
+        _delta3_index->set(e, _delta3->PRE_HEAP);
       }
       for (int i = 0; i < _blossom_num; ++i) {
-        (*_delta2_index)[i] = _delta2->PRE_HEAP;
-        (*_delta4_index)[i] = _delta4->PRE_HEAP;
+        _delta2_index->set(i, _delta2->PRE_HEAP);
+        _delta4_index->set(i, _delta4->PRE_HEAP);
       }
 
@@ -2851,5 +2851,5 @@
           }
         }
-        (*_node_index)[n] = index;
+        _node_index->set(n, index);
         (*_node_data)[index].pot = max;
         int blossom =
Index: lemon/min_cost_arborescence.h
===================================================================
--- lemon/min_cost_arborescence.h	(revision 576)
+++ lemon/min_cost_arborescence.h	(revision 550)
@@ -91,8 +91,8 @@
   /// \ingroup spantree
   ///
-  /// \brief Minimum Cost Arborescence algorithm class.
+  /// \brief %MinCostArborescence algorithm class.
   ///
   /// This class provides an efficient implementation of
-  /// Minimum Cost Arborescence algorithm. The arborescence is a tree
+  /// %MinCostArborescence algorithm. The arborescence is a tree
   /// which is directed from a given source node of the digraph. One or
   /// more sources should be given for the algorithm and it will calculate
@@ -294,5 +294,5 @@
         }
       }
-      (*_arc_order)[minimum.arc] = _dual_variables.size();
+      _arc_order->set(minimum.arc, _dual_variables.size());
       DualVariable var(_dual_node_list.size() - 1,
                        _dual_node_list.size(), minimum.value);
@@ -336,5 +336,5 @@
         }
       }
-      (*_arc_order)[minimum.arc] = _dual_variables.size();
+      _arc_order->set(minimum.arc, _dual_variables.size());
       DualVariable var(node_bottom, _dual_node_list.size(), minimum.value);
       _dual_variables.push_back(var);
@@ -365,5 +365,5 @@
         Node source = _heap->top();
         _heap->pop();
-        (*_node_order)[source] = -1;
+        _node_order->set(source, -1);
         for (OutArcIt it(*_digraph, source); it != INVALID; ++it) {
           if ((*_arc_order)[it] < 0) continue;
@@ -391,5 +391,5 @@
   public:
 
-    /// \name Named Template Parameters
+    /// \name Named template parameters
 
     /// @{
@@ -631,5 +631,5 @@
     /// @}
 
-    /// \name Execution Control
+    /// \name Execution control
     /// The simplest way to execute the algorithm is to use
     /// one of the member functions called \c run(...). \n
@@ -651,11 +651,11 @@
       for (NodeIt it(*_digraph); it != INVALID; ++it) {
         (*_cost_arcs)[it].arc = INVALID;
-        (*_node_order)[it] = -3;
-        (*_heap_cross_ref)[it] = Heap::PRE_HEAP;
+        _node_order->set(it, -3);
+        _heap_cross_ref->set(it, Heap::PRE_HEAP);
         _pred->set(it, INVALID);
       }
       for (ArcIt it(*_digraph); it != INVALID; ++it) {
         _arborescence->set(it, false);
-        (*_arc_order)[it] = -1;
+        _arc_order->set(it, -1);
       }
       _dual_node_list.clear();
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 573)
+++ lemon/preflow.h	(revision 550)
@@ -405,5 +405,5 @@
       _phase = true;
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_excess)[n] = 0;
+        _excess->set(n, 0);
       }
 
@@ -418,8 +418,8 @@
 
       std::vector<Node> queue;
-      reached[_source] = true;
+      reached.set(_source, true);
 
       queue.push_back(_target);
-      reached[_target] = true;
+      reached.set(_target, true);
       while (!queue.empty()) {
         _level->initNewLevel();
@@ -430,5 +430,5 @@
             Node u = _graph.source(e);
             if (!reached[u] && _tolerance.positive((*_capacity)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -445,5 +445,5 @@
           if ((*_level)[u] == _level->maxLevel()) continue;
           _flow->set(e, (*_capacity)[e]);
-          (*_excess)[u] += (*_capacity)[e];
+          _excess->set(u, (*_excess)[u] + (*_capacity)[e]);
           if (u != _target && !_level->active(u)) {
             _level->activate(u);
@@ -479,5 +479,5 @@
         }
         if (excess < 0 && n != _source) return false;
-        (*_excess)[n] = excess;
+        _excess->set(n, excess);
       }
 
@@ -488,8 +488,8 @@
 
       std::vector<Node> queue;
-      reached[_source] = true;
+      reached.set(_source, true);
 
       queue.push_back(_target);
-      reached[_target] = true;
+      reached.set(_target, true);
       while (!queue.empty()) {
         _level->initNewLevel();
@@ -501,5 +501,5 @@
             if (!reached[u] &&
                 _tolerance.positive((*_capacity)[e] - (*_flow)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -509,5 +509,5 @@
             Node v = _graph.target(e);
             if (!reached[v] && _tolerance.positive((*_flow)[e])) {
-              reached[v] = true;
+              reached.set(v, true);
               _level->initAddItem(v);
               nqueue.push_back(v);
@@ -525,5 +525,5 @@
           if ((*_level)[u] == _level->maxLevel()) continue;
           _flow->set(e, (*_capacity)[e]);
-          (*_excess)[u] += rem;
+          _excess->set(u, (*_excess)[u] + rem);
           if (u != _target && !_level->active(u)) {
             _level->activate(u);
@@ -537,5 +537,5 @@
           if ((*_level)[v] == _level->maxLevel()) continue;
           _flow->set(e, 0);
-          (*_excess)[v] += rem;
+          _excess->set(v, (*_excess)[v] + rem);
           if (v != _target && !_level->active(v)) {
             _level->activate(v);
@@ -578,10 +578,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] + excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_1;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, (*_capacity)[e]);
               }
@@ -601,10 +601,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] - excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_1;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, 0);
               }
@@ -616,5 +616,5 @@
         no_more_push_1:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -651,10 +651,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] + excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_2;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, (*_capacity)[e]);
               }
@@ -674,10 +674,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] - excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_2;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, 0);
               }
@@ -689,5 +689,5 @@
         no_more_push_2:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -732,5 +732,5 @@
       typename Digraph::template NodeMap<bool> reached(_graph);
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        reached[n] = (*_level)[n] < _level->maxLevel();
+        reached.set(n, (*_level)[n] < _level->maxLevel());
       }
 
@@ -740,5 +740,5 @@
       std::vector<Node> queue;
       queue.push_back(_source);
-      reached[_source] = true;
+      reached.set(_source, true);
 
       while (!queue.empty()) {
@@ -750,5 +750,5 @@
             Node v = _graph.target(e);
             if (!reached[v] && _tolerance.positive((*_flow)[e])) {
-              reached[v] = true;
+              reached.set(v, true);
               _level->initAddItem(v);
               nqueue.push_back(v);
@@ -759,5 +759,5 @@
             if (!reached[u] &&
                 _tolerance.positive((*_capacity)[e] - (*_flow)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -793,10 +793,10 @@
             if (!_tolerance.less(rem, excess)) {
               _flow->set(e, (*_flow)[e] + excess);
-              (*_excess)[v] += excess;
+              _excess->set(v, (*_excess)[v] + excess);
               excess = 0;
               goto no_more_push;
             } else {
               excess -= rem;
-              (*_excess)[v] += rem;
+              _excess->set(v, (*_excess)[v] + rem);
               _flow->set(e, (*_capacity)[e]);
             }
@@ -816,10 +816,10 @@
             if (!_tolerance.less(rem, excess)) {
               _flow->set(e, (*_flow)[e] - excess);
-              (*_excess)[v] += excess;
+              _excess->set(v, (*_excess)[v] + excess);
               excess = 0;
               goto no_more_push;
             } else {
               excess -= rem;
-              (*_excess)[v] += rem;
+              _excess->set(v, (*_excess)[v] + rem);
               _flow->set(e, 0);
             }
@@ -831,5 +831,5 @@
       no_more_push:
 
-        (*_excess)[n] = excess;
+        _excess->set(n, excess);
 
         if (excess != 0) {
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 576)
+++ lemon/random.h	(revision 550)
@@ -660,5 +660,5 @@
     /// @}
 
-    ///\name Uniform Distributions
+    ///\name Uniform distributions
     ///
     /// @{
@@ -763,5 +763,5 @@
     /// @}
 
-    ///\name Non-uniform Distributions
+    ///\name Non-uniform distributions
     ///
     ///@{
@@ -939,5 +939,5 @@
     ///@}
 
-    ///\name Two Dimensional Distributions
+    ///\name Two dimensional distributions
     ///
     ///@{
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 574)
+++ lemon/smart_graph.h	(revision 550)
@@ -192,5 +192,7 @@
   ///that <b> it does support only limited (only stack-like)
   ///node and arc deletions</b>.
-  ///It fully conforms to the \ref concepts::Digraph "Digraph concept".
+  ///It conforms to the \ref concepts::Digraph "Digraph concept" with
+  ///an important extra feature that its maps are real \ref
+  ///concepts::ReferenceMap "reference map"s.
   ///
   ///\sa concepts::Digraph.
@@ -628,7 +630,13 @@
   /// that <b> it does support only limited (only stack-like)
   /// node and arc deletions</b>.
-  /// It fully conforms to the \ref concepts::Graph "Graph concept".
+  /// Except from this it conforms to
+  /// the \ref concepts::Graph "Graph concept".
+  ///
+  /// It also has an
+  /// important extra feature that
+  /// its maps are real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// \sa concepts::Graph.
+  ///
   class SmartGraph : public ExtendedSmartGraphBase {
   private:
Index: lemon/soplex.cc
===================================================================
--- lemon/soplex.cc	(revision 568)
+++ lemon/soplex.cc	(revision 528)
@@ -21,5 +21,4 @@
 
 #include <soplex.h>
-#include <spxout.h>
 
 
@@ -30,5 +29,4 @@
   SoplexLp::SoplexLp() {
     soplex = new soplex::SoPlex;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -50,5 +48,4 @@
     _row_names_ref = lp._row_names_ref;
 
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -275,6 +272,4 @@
 
     _clear_temporals();
-    
-    _applyMessageLevel();
 
     soplex::SPxSolver::Status status = soplex->solve();
@@ -425,28 +420,4 @@
   }
 
-  void SoplexLp::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = -1;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = soplex::SPxOut::ERROR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = soplex::SPxOut::WARNING;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = soplex::SPxOut::INFO2;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = soplex::SPxOut::DEBUG;
-      break;
-    }
-  }
-
-  void SoplexLp::_applyMessageLevel() {
-    soplex::Param::setVerbose(_message_level);
-  }
-
 } //namespace lemon
 
Index: lemon/soplex.h
===================================================================
--- lemon/soplex.h	(revision 568)
+++ lemon/soplex.h	(revision 528)
@@ -145,9 +145,4 @@
     virtual void _clear();
 
-    void _messageLevel(MessageLevel m);
-    void _applyMessageLevel();
-
-    int _message_level;
-
   };
 
Index: lemon/suurballe.h
===================================================================
--- lemon/suurballe.h	(revision 576)
+++ lemon/suurballe.h	(revision 550)
@@ -289,5 +289,5 @@
     }
 
-    /// \name Execution Control
+    /// \name Execution control
     /// The simplest way to execute the algorithm is to call the run()
     /// function.
Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 576)
+++ lemon/time_measure.h	(revision 537)
@@ -288,5 +288,5 @@
     Timer(bool run=true) :_running(run) {_reset();}
 
-    ///\name Control the State of the Timer
+    ///\name Control the state of the timer
     ///Basically a Timer can be either running or stopped,
     ///but it provides a bit finer control on the execution.
@@ -396,5 +396,5 @@
     ///@}
 
-    ///\name Query Functions for the Ellapsed Time
+    ///\name Query Functions for the ellapsed time
 
     ///@{
Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 577)
+++ test/bfs_test.cc	(revision 440)
@@ -59,16 +59,14 @@
 
   Digraph G;
-  Node s, t, n;
+  Node s, t;
   Arc e;
-  int l, i;
+  int l;
   bool b;
   BType::DistMap d(G);
   BType::PredMap p(G);
   Path<Digraph> pp;
-  concepts::ReadMap<Node,bool> nm;
 
   {
     BType bfs_test(G);
-    const BType& const_bfs_test = bfs_test;
 
     bfs_test.run(s);
@@ -76,24 +74,11 @@
     bfs_test.run();
 
-    bfs_test.init();
-    bfs_test.addSource(s);
-    n = bfs_test.processNextNode();
-    n = bfs_test.processNextNode(t, b);
-    n = bfs_test.processNextNode(nm, n);
-    n = const_bfs_test.nextNode();
-    b = const_bfs_test.emptyQueue();
-    i = const_bfs_test.queueSize();
-    
-    bfs_test.start();
-    bfs_test.start(t);
-    bfs_test.start(nm);
-
-    l  = const_bfs_test.dist(t);
-    e  = const_bfs_test.predArc(t);
-    s  = const_bfs_test.predNode(t);
-    b  = const_bfs_test.reached(t);
-    d  = const_bfs_test.distMap();
-    p  = const_bfs_test.predMap();
-    pp = const_bfs_test.path(t);
+    l  = bfs_test.dist(t);
+    e  = bfs_test.predArc(t);
+    s  = bfs_test.predNode(t);
+    b  = bfs_test.reached(t);
+    d  = bfs_test.distMap();
+    p  = bfs_test.predMap();
+    pp = bfs_test.path(t);
   }
   {
@@ -102,35 +87,11 @@
       ::SetDistMap<concepts::ReadWriteMap<Node,int> >
       ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::Create bfs_test(G);
-      
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,int> dist_map;
-    concepts::ReadWriteMap<Node,bool> reached_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    
-    bfs_test
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .reachedMap(reached_map)
-      .processedMap(processed_map);
 
     bfs_test.run(s);
     bfs_test.run(s,t);
     bfs_test.run();
-    
-    bfs_test.init();
-    bfs_test.addSource(s);
-    n = bfs_test.processNextNode();
-    n = bfs_test.processNextNode(t, b);
-    n = bfs_test.processNextNode(nm, n);
-    n = bfs_test.nextNode();
-    b = bfs_test.emptyQueue();
-    i = bfs_test.queueSize();
-    
-    bfs_test.start();
-    bfs_test.start(t);
-    bfs_test.start(nm);
 
     l  = bfs_test.dist(t);
Index: test/circulation_test.cc
===================================================================
--- test/circulation_test.cc	(revision 577)
+++ test/circulation_test.cc	(revision 440)
@@ -72,20 +72,16 @@
   FlowMap flow;
   BarrierMap bar;
-  VType v;
-  bool b;
 
-  typedef Circulation<Digraph, CapMap, CapMap, DeltaMap>
-            ::SetFlowMap<FlowMap>
-            ::SetElevator<Elev>
-            ::SetStandardElevator<LinkedElev>
-            ::Create CirculationType;
-  CirculationType circ_test(g, lcap, ucap, delta);
-  const CirculationType& const_circ_test = circ_test;
-   
-  circ_test
-    .lowerCapMap(lcap)
-    .upperCapMap(ucap)
-    .deltaMap(delta)
-    .flowMap(flow);
+  Circulation<Digraph, CapMap, CapMap, DeltaMap>
+    ::SetFlowMap<FlowMap>
+    ::SetElevator<Elev>
+    ::SetStandardElevator<LinkedElev>
+    ::Create circ_test(g,lcap,ucap,delta);
+
+  circ_test.lowerCapMap(lcap);
+  circ_test.upperCapMap(ucap);
+  circ_test.deltaMap(delta);
+  flow = circ_test.flowMap();
+  circ_test.flowMap(flow);
 
   circ_test.init();
@@ -94,10 +90,7 @@
   circ_test.run();
 
-  v = const_circ_test.flow(a);
-  const FlowMap& fm = const_circ_test.flowMap();
-  b = const_circ_test.barrier(n);
-  const_circ_test.barrierMap(bar);
-  
-  ignore_unused_variable_warning(fm);
+  circ_test.barrier(n);
+  circ_test.barrierMap(bar);
+  circ_test.flow(a);
 }
 
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 577)
+++ test/dfs_test.cc	(revision 440)
@@ -63,14 +63,12 @@
   Node s, t;
   Arc e;
-  int l, i;
+  int l;
   bool b;
   DType::DistMap d(G);
   DType::PredMap p(G);
   Path<Digraph> pp;
-  concepts::ReadMap<Arc,bool> am;
 
   {
     DType dfs_test(G);
-    const DType& const_dfs_test = dfs_test;
 
     dfs_test.run(s);
@@ -78,22 +76,11 @@
     dfs_test.run();
 
-    dfs_test.init();
-    dfs_test.addSource(s);
-    e = dfs_test.processNextArc();
-    e = const_dfs_test.nextArc();
-    b = const_dfs_test.emptyQueue();
-    i = const_dfs_test.queueSize();
-    
-    dfs_test.start();
-    dfs_test.start(t);
-    dfs_test.start(am);
-
-    l  = const_dfs_test.dist(t);
-    e  = const_dfs_test.predArc(t);
-    s  = const_dfs_test.predNode(t);
-    b  = const_dfs_test.reached(t);
-    d  = const_dfs_test.distMap();
-    p  = const_dfs_test.predMap();
-    pp = const_dfs_test.path(t);
+    l  = dfs_test.dist(t);
+    e  = dfs_test.predArc(t);
+    s  = dfs_test.predNode(t);
+    b  = dfs_test.reached(t);
+    d  = dfs_test.distMap();
+    p  = dfs_test.predMap();
+    pp = dfs_test.path(t);
   }
   {
@@ -102,33 +89,11 @@
       ::SetDistMap<concepts::ReadWriteMap<Node,int> >
       ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::Create dfs_test(G);
-
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,int> dist_map;
-    concepts::ReadWriteMap<Node,bool> reached_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    
-    dfs_test
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .reachedMap(reached_map)
-      .processedMap(processed_map);
 
     dfs_test.run(s);
     dfs_test.run(s,t);
     dfs_test.run();
-    dfs_test.init();
-
-    dfs_test.addSource(s);
-    e = dfs_test.processNextArc();
-    e = dfs_test.nextArc();
-    b = dfs_test.emptyQueue();
-    i = dfs_test.queueSize();
-    
-    dfs_test.start();
-    dfs_test.start(t);
-    dfs_test.start(am);
 
     l  = dfs_test.dist(t);
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 577)
+++ test/dijkstra_test.cc	(revision 440)
@@ -61,8 +61,7 @@
 
   Digraph G;
-  Node s, t, n;
+  Node s, t;
   Arc e;
   VType l;
-  int i;
   bool b;
   DType::DistMap d(G);
@@ -70,34 +69,18 @@
   LengthMap length;
   Path<Digraph> pp;
-  concepts::ReadMap<Node,bool> nm;
 
   {
     DType dijkstra_test(G,length);
-    const DType& const_dijkstra_test = dijkstra_test;
 
     dijkstra_test.run(s);
     dijkstra_test.run(s,t);
 
-    dijkstra_test.init();
-    dijkstra_test.addSource(s);
-    dijkstra_test.addSource(s, 1);
-    n = dijkstra_test.processNextNode();
-    n = const_dijkstra_test.nextNode();
-    b = const_dijkstra_test.emptyQueue();
-    i = const_dijkstra_test.queueSize();
-    
-    dijkstra_test.start();
-    dijkstra_test.start(t);
-    dijkstra_test.start(nm);
-
-    l  = const_dijkstra_test.dist(t);
-    e  = const_dijkstra_test.predArc(t);
-    s  = const_dijkstra_test.predNode(t);
-    b  = const_dijkstra_test.reached(t);
-    b  = const_dijkstra_test.processed(t);
-    d  = const_dijkstra_test.distMap();
-    p  = const_dijkstra_test.predMap();
-    pp = const_dijkstra_test.path(t);
-    l  = const_dijkstra_test.currentDist(t);
+    l  = dijkstra_test.dist(t);
+    e  = dijkstra_test.predArc(t);
+    s  = dijkstra_test.predNode(t);
+    b  = dijkstra_test.reached(t);
+    d  = dijkstra_test.distMap();
+    p  = dijkstra_test.predMap();
+    pp = dijkstra_test.path(t);
   }
   {
@@ -105,40 +88,13 @@
       ::SetPredMap<concepts::ReadWriteMap<Node,Arc> >
       ::SetDistMap<concepts::ReadWriteMap<Node,VType> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetOperationTraits<DijkstraDefaultOperationTraits<VType> >
       ::SetHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
       ::SetStandardHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
-      ::SetHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> >, 
-                concepts::ReadWriteMap<Node,int> >
       ::Create dijkstra_test(G,length);
-
-    LengthMap length_map;
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,VType> dist_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    concepts::ReadWriteMap<Node,int> heap_cross_ref;
-    BinHeap<VType, concepts::ReadWriteMap<Node,int> > heap(heap_cross_ref);
-    
-    dijkstra_test
-      .lengthMap(length_map)
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .processedMap(processed_map)
-      .heap(heap, heap_cross_ref);
 
     dijkstra_test.run(s);
     dijkstra_test.run(s,t);
-
-    dijkstra_test.addSource(s);
-    dijkstra_test.addSource(s, 1);
-    n = dijkstra_test.processNextNode();
-    n = dijkstra_test.nextNode();
-    b = dijkstra_test.emptyQueue();
-    i = dijkstra_test.queueSize();
-    
-    dijkstra_test.start();
-    dijkstra_test.start(t);
-    dijkstra_test.start(nm);
 
     l  = dijkstra_test.dist(t);
@@ -146,7 +102,5 @@
     s  = dijkstra_test.predNode(t);
     b  = dijkstra_test.reached(t);
-    b  = dijkstra_test.processed(t);
     pp = dijkstra_test.path(t);
-    l  = dijkstra_test.currentDist(t);
   }
 
